# @(#)65	1.1	src/rsct/ffdc/bin/fcjoin.sed, ffdc, rsct_rbra, rbra0445a 9/14/00 16:42:08
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2000,2004 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# =============================================================================
# Module Name:	fc_join.sed
#
# Component:	ffdc
#
# Description:	A "sed" script to be used on a Syslog configuration file (ex:
#		/etc/syslog.conf) to collapse multiple lined entries into single
#		lines.  Also removes any blank space from the head of the
#		lines being joined to the previously held line.
#
#		This "sed" script is to be executed after another facility has
#		preprocessed the Syslog configuration file to remove al comments
#		and blank lines.  This is to prevent comments from being
#		embedded in a multiple line entry.
#
# Usage:	sed -f fc_strip.sed <Syslog_configuration_file> | \
#		sed -f fc_join.sed
#
# Input:	Preprocessed Syslog configuration file, with comments and blank
#		lines removed.
#
# Output:	Syslog configuration file with comments and blank lines removed,
#		and multiple line entries collapsed into a single line.
#
# Exit Status:	Set by "sed"
# =============================================================================
:join
/\\$/{
N
s/\\\n[	 ]*//
b join
}
